#include "jserver.h"

/* this file is only for the executable version of the jabber server */

int main (int argc, char** argv)
{
    pth_event_t sigevt;
    sigset_t set;
    int help, sig, i, sz;
    char *cfgfile = NULL, *c;

    help = 0;
    for(i = 1; i < argc; i++)
    {
        c = argv[i] + 1;
        switch(*c)
        {
            case 'D':
                etherx_debug();
                break;
            case 'c':
                cfgfile = strdup(argv[++i]);
                break;
            default:
                help = 1;
        }
    }
 
    if(help)
    {
        printf("Usage:\njserver [-D] [-c config.xml]\n");
        exit(0);
    }
 
    log_init(LOGSTDERR, NULL);

    log_warn("jserver","starting transport");

    /* optionally pre-load the config if it was manually set */
    if(cfgfile != NULL)
        if(js_config(cfgfile) == NULL)
            exit(1);

    jabber_transport(); /* fire it up baby! */

    sigemptyset(&set);
    sigaddset(&set, SIGHUP);
    sigaddset(&set, SIGINT);
    sigaddset(&set, SIGTERM);
    pth_sigmask(SIG_UNBLOCK, &set, NULL);
    sigevt = pth_event(PTH_EVENT_SIGS, &set, &sig);
 
    log_debug(ZONE,"Main loop waiting");
    pth_wait(sigevt);

    log_error("jserver","Received KILL, shutting down");
    jabber_transport_exit();
    pth_sleep(1); /* one last chance to make sure everyone is done */
    pth_kill();
    return 0;
}
