#include "jserver.h"

thread mod_log_device = NULL;

void mod_log_init()
{
    int fd;
    char *file;

    file = xmlnode_get_data(js_config("log"));
    fd = open(file, O_WRONLY | O_CREAT | O_APPEND, 0600);
    if(file == NULL || fd < 0)
    {
        log_error("jserver","unable to open log file");
        return;
    }

    mod_log_device = tstream_new(fd,"logger",NULL,NULL,NULL);
}

/* logs session characteristics */
mreturn mod_log_session_end(mapi m, void *arg)
{
    pth_attr_t attr;
    pth_time_t started, total;
    static char log[1024];
    int size;
    time_t t;

    if(mod_log_device == NULL)
        return;

    log_debug("mod_log","creating log entry");

    attr = pth_attr_of(m->s->t->id);
    pth_attr_get(attr,PTH_ATTR_TIME_SPAWN,&started);
    pth_attr_get(attr,PTH_ATTR_TIME_RAN,&total);
    pth_attr_destroy(attr);
    t = time(NULL);

    /* TIMESTAMP TOTALSECONDS PACKETSFROM PACKETSTO USER@HOST/RES */
    size = snprintf(log, 1024, "%s %d %d %d %s\n",
        create_log_timestamp(),
        t - started.tv_sec,
        m->s->c_in,
        m->s->c_out,
        jid_full(m->s->id));

    tstream_write(mod_log_device,log,size);

    log_debug("CPU","%s used %d.%d CPU time",jid_full(m->s->id),total.tv_sec,total.tv_usec);

    return M_PASS;
}

mreturn mod_log_session(mapi m, void *arg)
{
    js_mapi_session(PS_END, m->s, mod_log_session_end, NULL);

    return M_PASS;
}

void mod_log(void)
{
    log_debug("mod_log","init");
    mod_log_init();
    js_mapi_register(P_SESSION, mod_log_session, NULL);
}

