#include "jserver.h"


sreturn js_service_prescreen(jpacket p)
{
    static mmaster om = NULL;
    udata user;

    if(om == NULL) om = js_mapi_master(P_OFFLINE);

    if(p == NULL) return S_IGNORE;

    if(p->type == JPACKET_IQ && NSCHECK(p->iq,NS_AUTH))
    {
        log_debug(ZONE,"auth request");

        user = js_user(xmlnode_get_tag_data(p->iq, "username"));
        if(user == NULL)
        { /* no user on this server */
            js_error(p->x, TERROR_AUTH);
        }else{
            if(js_mapi_call(P_OFFLINE, om->l, p, user, NULL, MAPI_VARAUTH))
            { /* someone handled it */
                jpacket_reset(p);
                if(jpacket_subtype(p) == JPACKET__RESULT)
                    return S_AUTHED;
            }else{ /* nobody understood the auth */
                js_error(p->x, TERROR_INTERNAL);
            }
        }
    }else if(p->type == JPACKET_IQ && NSCHECK(p->iq,NS_REGISTER)){
        log_debug(ZONE,"registration request");

        if(!js_mapi_call(P_OFFLINE, om->l, p, NULL, NULL, MAPI_VARREGISTER))
            js_error(p->x, TERROR_NOTIMPL);
    }else{
        js_error(p->x, TERROR_AUTH);
    }

    return S_BOUNCE;
}
